function [Z]=       impmetXm( EdgesTotal,TrianglesTotal,...
                            EdgeLength,K,...
                            Center,Center_,...
                            TrianglePlus,TriangleMinus,...
                            RHO_P,RHO_M,...
                            RHO__Plus,RHO__Minus,...
                            FactorA,FactorFi);   
%IMPMET
%
%	迹 [EdgesTotal x EdgesTotal]
%	9ַͬʱҲ㣩
%%
% *  ÿ9ֵ
%   (barycentric subdivision)
%
%   迹㷨¼B

%  Z󴴽
Z   =zeros  (EdgesTotal,EdgesTotal)+1i*zeros(EdgesTotal,EdgesTotal);

% λѭ  һѭÿ ζzĹ׼ӵzжӦ
for p=1:TrianglesTotal
    Plus     =find(TrianglePlus-p==0);  %ҵpζӦļǵԪбΪǣ03Ϊ3ߣӦڼԪ
    Minus    =find(TriangleMinus-p==0); %ҵpζӦļǵԪбΪ
    %9ǵĵȥpε 
    D=Center_-repmat(Center(:,p),[1 9 TrianglesTotal]); %[3 9 TrianglesTotal]     
    %D.......   
    R=sqrt(sum(D.*D));            %[1 9 TrianglesTotal] pĵĵľ
    g=sin(K/(1i)*R);               %[1 9 TrianglesTotal]  ֺpĵĵľĸֺ
       
    gP=g(:,:,TrianglePlus);       %[1 9 EdgesTotal]pĵбΪģĵľĸֺ
    gM=g(:,:,TriangleMinus);                        %[1 9 EdgesTotal]
        
    Fi=sum(gP)-sum(gM);                             %[1 1 EdgesTotal]%ǻԪֺ֮
    ZF= FactorFi.*reshape(Fi,EdgesTotal,1);          %[EdgesTotal 1] B5ʽһ
    
    g1=cos(K/(1i)*R)./R;               %[1 9 TrianglesTotal]  ֺpĵĵľĸֺ
       
    gP1=g1(:,:,TrianglePlus);       %[1 9 EdgesTotal]pĵбΪģĵľĸֺ
    gM1=g1(:,:,TriangleMinus);                        %[1 9 EdgesTotal]
        
    %B5һ  ÿǰ
    for k=1:length(Plus)
        n=Plus(k);   %TrianglePlusĵnУnRWGԪpαΪ
        RP=repmat(RHO__Plus(:,:,n),[1 1 EdgesTotal]);         %[3 9 EdgesTotal]nRWGԪеǵľŸεpk_+
        A=sum(gP.*sum(RP.*RHO_P))+sum(gM.*sum(RP.*RHO_M));
        Z1= FactorA.*reshape(A,EdgesTotal,1);   
        A2=sum(gP1.*sum(RP.*RHO_P))+sum(gM1.*sum(RP.*RHO_M));
        Z2= FactorA.*reshape(A2,EdgesTotal,1); 
        Z(:,n)=Z(:,n)-K/(1i)/2*EdgeLength(n)*(Z1+ZF)+EdgeLength(n)*Z2;
    end
    for k=1:length(Minus)
        n=Minus(k);
        RP=repmat(RHO__Minus(:,:,n),[1 1 EdgesTotal]);        %[3 9 EdgesTotal]
        A=sum(gP.*sum(RP.*RHO_P))+sum(gM.*sum(RP.*RHO_M));
        Z1= FactorA.*reshape(A,EdgesTotal,1); 
        A2=sum(gP1.*sum(RP.*RHO_P))+sum(gM1.*sum(RP.*RHO_M));
        Z2= FactorA.*reshape(A2,EdgesTotal,1); 
        Z(:,n)=Z(:,n)-K/(1i)/2*EdgeLength(n)*(Z1-ZF)+EdgeLength(n)*Z2; 
    end
end